# PictureViewer

Package imp

## Class PictureViewer

- java.lang.Object
- - javafx.scene.Node
  - - javafx.scene.Parent
    - - javafx.scene.layout.Region
      - - javafx.scene.control.Control
        - - javafx.scene.control.ScrollPane
          - - imp.PictureViewer

All Implemented Interfaces:
  `javafx.css.Styleable`, `javafx.event.EventTarget`, `javafx.scene.control.Skinnable`

    public class PictureViewer
    extends javafx.scene.control.ScrollPane

### Nested Class Summary

### Nested classes/interfaces inherited from class javafx.scene.control.ScrollPane

`javafx.scene.control.ScrollPane.ScrollBarPolicy`

### Field Summary

Fields
`static int` `FIT`
`static int` `NORMAL`

### Fields inherited from class javafx.scene.layout.Region

`USE_COMPUTED_SIZE, USE_PREF_SIZE`

### Fields inherited from class javafx.scene.Node

`BASELINE_OFFSET_SAME_AS_HEIGHT`

### Constructor Summary

Constructors
`PictureViewer()` Erzeugt ein ScrollPanel mit integriertem Bild der Größe 1000x1000
`PictureViewer​(int width, int height)` Erzeugt ein ScrollPanel mit integriertem Bild der angegebenen Größe
`PictureViewer​(int width, int height, java.lang.String background)` Erzeugt ein ScrollPanel mit integriertem Bild der angegebenen Größe
`PictureViewer​(imp.Picture picture)` Erzeugt ein ScrollPanel und zeigt das Bild-Objekt an
`PictureViewer​(java.lang.String filename)` Erzeugt ein ScrollPanel mit integriertem Bild aus einer Bilddatei

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `back()` Ruft das letzte abgespeicherte Bild aus der History wieder auf.
`imp.Picture` `getImage()` Liefert das angezeigte Bild
`void` `pushImage()` Speichert das übergebene Bild in der History.
`void` `repaint()` Setzt das angezeigt Bild neu und beachtet dabei den Zoomfaktor.
`void` `setImage​(imp.Picture picture, boolean saveOldImage)` Setzt das anzuzeigende Bild neu
`void` `setZoom​(double factor)` Setzt den Zoom-Faktor für das Bild.

### Methods inherited from class javafx.scene.control.ScrollPane

`contentProperty, createDefaultSkin, fitToHeightProperty, fitToWidthProperty, getClassCssMetaData, getContent, getControlCssMetaData, getHbarPolicy, getHmax, getHmin, getHvalue, getInitialFocusTraversable, getMinViewportHeight, getMinViewportWidth, getPrefViewportHeight, getPrefViewportWidth, getVbarPolicy, getViewportBounds, getVmax, getVmin, getVvalue, hbarPolicyProperty, hmaxProperty, hminProperty, hvalueProperty, isFitToHeight, isFitToWidth, isPannable, minViewportHeightProperty, minViewportWidthProperty, pannableProperty, prefViewportHeightProperty, prefViewportWidthProperty, queryAccessibleAttribute, setContent, setFitToHeight, setFitToWidth, setHbarPolicy, setHmax, setHmin, setHvalue, setMinViewportHeight, setMinViewportWidth, setPannable, setPrefViewportHeight, setPrefViewportWidth, setVbarPolicy, setViewportBounds, setVmax, setVmin, setVvalue, vbarPolicyProperty, viewportBoundsProperty, vmaxProperty, vminProperty, vvalueProperty`

### Methods inherited from class javafx.scene.control.Control

`computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, contextMenuProperty, executeAccessibleAction, getBaselineOffset, getContextMenu, getCssMetaData, getSkin, getTooltip, isResizable, layoutChildren, setContextMenu, setSkin, setTooltip, skinProperty, tooltipProperty`

### Methods inherited from class javafx.scene.layout.Region

`backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPositionX, snapPositionY, snapSizeX, snapSizeY, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

### Methods inherited from class javafx.scene.Parent

`getChildren, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

### Methods inherited from class javafx.scene.Node

`accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.css.Styleable

`getStyleableNode`

### Field Detail

#### FIT

    public static final int FIT

See Also:
  Constant Field Values

#### NORMAL

    public static final int NORMAL

See Also:
  Constant Field Values

### Constructor Detail

#### PictureViewer

    public PictureViewer()

Erzeugt ein ScrollPanel mit integriertem Bild der Größe 1000x1000

#### PictureViewer

    public PictureViewer​(int width,
                         int height)

Erzeugt ein ScrollPanel mit integriertem Bild der angegebenen Größe

Parameters:
  `width` - Breite des Bildes
  `height` - Höhe des Bildes

#### PictureViewer

    public PictureViewer​(int width,
                         int height,
                         java.lang.String background)

Erzeugt ein ScrollPanel mit integriertem Bild der angegebenen Größe

Parameters:
  `width` - Breite des Bildes
  `height` - Höhe des Bildes
  `background` - Farbe des Hintergrunds als HEX-String (z.B. "FF3A45")

#### PictureViewer

    public PictureViewer​(java.lang.String filename)

Erzeugt ein ScrollPanel mit integriertem Bild aus einer Bilddatei

Parameters:
  `filename` - Name des Bildes

#### PictureViewer

    public PictureViewer​(imp.Picture picture)

Erzeugt ein ScrollPanel und zeigt das Bild-Objekt an

Parameters:
  `picture` - anzuzeigendes Bild

### Method Detail

#### setImage

    public void setImage​(imp.Picture picture,
                         boolean saveOldImage)

Setzt das anzuzeigende Bild neu

Parameters:
  `picture` - anzuzeigendes Bild
  `saveOldImage` - soll das aktuelle Bild in der Historie gespeichert werden

#### getImage

    public imp.Picture getImage()

Liefert das angezeigte Bild

Returns:
  angezeigtes Bild

#### pushImage

    public void pushImage()

Speichert das übergebene Bild in der History.

Parameters:
  `b` - zu speicherndes Bild

#### back

    public void back()

Ruft das letzte abgespeicherte Bild aus der History wieder auf.

#### repaint

    public void repaint()

Setzt das angezeigt Bild neu und beachtet dabei den Zoomfaktor.

#### setZoom

    public void setZoom​(double factor)

Setzt den Zoom-Faktor für das Bild. Als Zoomfaktor sind auch die Konstanten Bildanzeiger.FIT (auf Bildschirmgröße zoomen) und Bildanzeiger.NORMAL (100%) möglich.

Parameters:
  `factor` - Zoomfaktor (1.0 = 100%).